# Conditional build:
%bcond_without	tests	# perform "make check" (init_module seems to require root for mkdir)
#
Summary:	Linux kernel module handling
Summary(pl.UTF-8):	Obsługa modułów jądra Linuksa
Name:		kmod
Version:	15
Release:	1
License:	GPL v2+
Group:		Applications/System
Source0:	https://www.kernel.org/pub/linux/utils/kernel/kmod/%{name}-%{version}.tar.xz
# Source0-md5:	d03372179ed2cfa0c52b6672cf438901
Source1:	%{name}-blacklist
Source2:	%{name}-usb
Patch0:		%{name}-modprobe.d-kver.patch
URL:		http://git.kernel.org/?p=utils/kernel/kmod/kmod.git;a=summary
BuildRequires:	autoconf >= 2.60
BuildRequires:	automake >= 1:1.11
BuildRequires:	gtk-doc >= 1.14
BuildRequires:	libtool >= 2:2.0
BuildRequires:	pkgconfig
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRequires:	xz-devel >= 1:4.99
BuildRequires:	zlib-devel
Requires:	%{name}-libs = %{version}-%{release}
# won't work on older kernels as these do not provide require information in /sys
Requires:	uname(release) >= 2.6.21
Provides:	virtual(module-tools)
Provides:	module-init-tools = 4.0
Obsoletes:	module-init-tools < 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_bindir		/sbin

%description
kmod is a set of tools to handle common tasks with Linux kernel
modules like insert, remove, list, check properties, resolve
dependencies and aliases.

These tools are designed on top of libkmod, a library that is shipped
with kmod. See libkmod/README for more details on this library and how
to use it. The aim is to be compatible with tools, configurations and
indexes from module-init-tools project.

%description -l pl.UTF-8
kmod to zestaw narzędzi do wykonywania typowych czynności związanych z
modułami jądra - ładowanie, usuwanie, listowanie, sprawdzanie
parametrów, rozwiązywanie zależności czy obsługa aliasów.

Narzędzia te zostały stworzone przy użyciu libkmod, biblioteki
dostarczanej wraz z kmod. Celem jest stworzenie narzędzi
kompatybilnych z programami, konfiguracją oraz indeksami z projektu
module-init-tools.

%package libs
Summary:	Linux kernel module handling library
Summary(pl.UTF-8):	Biblioteka do obsługi modułów jądra Linuksa
License:	LGPL v2.1+
Group:		Libraries
Conflicts:	kmod < 4-1

%description libs
libkmod was created to allow programs to easily insert, remove and
list modules, also checking its properties, dependencies and aliases.

%description libs -l pl.UTF-8
Biblioteka libkmod została zaprojektowana, aby pozwolić programom w
łatwy sposób ładować, usuwać i listować moduły, także sprawdzając ich
właściwości, zależności i aliasy.

%package devel
Summary:	Header files for %{name} library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki %{name}
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Obsoletes:	kmod-libs-static

%description devel
Header files for %{name} library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki %{name}.

%package -n bash-completion-kmod
Summary:	bash-completion for kmod utilities
Summary(pl.UTF-8):	Bashowe uzupełnianie nazw dla narzędzi kmod
Group:		Applications/Shells
Requires:	bash-completion >= 2.0

%description -n bash-completion-kmod
bash-completion for kmod utilities.

%description -n bash-completion-kmod -l pl.UTF-8
Bashowe uzupełnianie nazw dla narzędzi kmod.

%prep
%setup -q
%patch0 -p1

# requires root to work
sed -i -e 's# testsuite/test-modprobe # #g' Makefile.am

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--disable-silent-rules \
	--with-rootlibdir=/%{_lib} \
	--with-xz \
	--with-zlib
%{__make}

%{?with_tests:%{__make} check}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/modprobe.d

%{__make} install \
	pkgconfigdir=%{_pkgconfigdir} \
	DESTDIR=$RPM_BUILD_ROOT

# install symlinks
for prog in lsmod rmmod insmod modinfo modprobe depmod; do
	ln -s kmod $RPM_BUILD_ROOT%{_bindir}/$prog
done

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libkmod.la

:> $RPM_BUILD_ROOT/etc/modprobe.d/modprobe.conf

install %{SOURCE1} $RPM_BUILD_ROOT/etc/modprobe.d/blacklist.conf
install %{SOURCE2} $RPM_BUILD_ROOT/etc/modprobe.d/usb.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc NEWS README TODO
%dir /etc/modprobe.d
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/blacklist.conf
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/modprobe.conf
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/usb.conf

%attr(755,root,root) %{_bindir}/kmod
%attr(755,root,root) %{_bindir}/lsmod
%attr(755,root,root) %{_bindir}/rmmod
%attr(755,root,root) %{_bindir}/insmod
%attr(755,root,root) %{_bindir}/modinfo
%attr(755,root,root) %{_bindir}/modprobe
%attr(755,root,root) %{_bindir}/depmod

%{_mandir}/man5/depmod.d.5*
%{_mandir}/man5/modprobe.d.5*
%{_mandir}/man5/modules.dep.5*
%{_mandir}/man5/modules.dep.bin.5*
%{_mandir}/man8/depmod.8*
%{_mandir}/man8/insmod.8*
%{_mandir}/man8/lsmod.8*
%{_mandir}/man8/modinfo.8*
%{_mandir}/man8/modprobe.8*
%{_mandir}/man8/rmmod.8*

%files libs
%defattr(644,root,root,755)
%doc libkmod/README
%attr(755,root,root) /%{_lib}/libkmod.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libkmod.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libkmod.so
%{_includedir}/libkmod.h
%{_pkgconfigdir}/libkmod.pc

%files -n bash-completion-kmod
%defattr(644,root,root,755)
%{_datadir}/bash-completion/completions/kmod
%changelog
* Thu Sep 12 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kmod.git;a=log;h=master

* Tue Aug 27 2013 Jakub Bogusz <qboosh@pld-linux.org> 34e8b92
- updated to 15

* Sat Jul 20 2013 Jan Rękorajski <baggins@pld-linux.org> 13d1dbf
- release 2 (by relup.sh)

* Fri Jul 05 2013 Jakub Bogusz <qboosh@pld-linux.org> d9def0b
- updated to 14; static is no more

* Fri May 17 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 0fa500b
- rel 2; blacklist snd-pcsp (speaker) driver

* Thu Apr 11 2013 Jakub Bogusz <qboosh@pld-linux.org> 7ff317f
- use upstream option to place libkmod in root libdir, avoid denormalized//paths

* Wed Apr 10 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 81e35d4
- up to 13

* Wed Dec 19 2012 Jan Rękorajski <baggins@pld-linux.org> 198a4cc
- provide module-init-tools for clean upgrade
- rel 3

* Wed Dec 12 2012 Jan Rękorajski <baggins@pld-linux.org> 185589b
- implemented TODO: /etc/modprobe.d/`uname -r` support
- second TODO item removed as it was purely cosmetic
- rel 2

* Fri Dec 07 2012 Adam Gołębiowski <adamg@pld-linux.org> ebe3a2c
- updated to 12

* Fri Nov 09 2012 Jakub Bogusz <qboosh@pld-linux.org> d7e51de
- .xz BRs

* Thu Nov 08 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 335eb04
- run (most of) test suite

* Thu Nov 08 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> dfd9013
- up to 11

* Sun Oct 21 2012 Jan Rękorajski <baggins@pld-linux.org> 3b166d2
- rebuild to fix broken filedigests
- release 2 (by relup.sh)

* Thu Sep 06 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 93ac00d
- up to 10

* Sun Jun 24 2012 Jakub Bogusz <qboosh@pld-linux.org> 60e11f6
- updated to 9; test suite apparently needs root now

* Thu Apr 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 136f0b0
- up to 8

* Mon Mar 26 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 9c7a43c
- no md5 for cvs patch

* Mon Mar 26 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> db8b44c
- rel 4

* Mon Mar 26 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> fbce3be
- store in cvs

* Thu Mar 22 2012 Elan Ruusamäe <glen@pld-linux.org> 1a7c804
- use softdep instead of install for ehci_hcd load order

